#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool ok(int n, int x)
{
    return x >= 0 && x < n;
}

void draw_stump(vector<string>& table, int x, int y)
{
    if (ok(table.size(), x) && ok(table.size(), y))
        table[y][x] = 'o';
    if (ok(table.size(), x-1) && ok(table.size(), y))
        table[y][x-1] = '_';
    if (ok(table.size(), x+1) && ok(table.size(), y))
        table[y][x+1] = '_';
}

void draw_tree(vector<string>& table, int x, int y, int s)
{
    if (ok(table.size(), x) && ok(table.size(), y))
        table[y][x] = '|';
    if (ok(table.size(), x-1) && ok(table.size(), y))
        table[y][x-1] = '_';
    if (ok(table.size(), x+1) && ok(table.size(), y))
        table[y][x+1] = '_';

    for (int i=0; i<s; ++i)
        if (ok(table.size(), x) && ok(table.size(), y+1+i))
            table[y+1+i][x] = '|';
    for (int i=0; i<s; ++i)
        if (ok(table.size(), x-1) && ok(table.size(), y+1+i))
            table[y+1+i][x-1] = '/';
    for (int i=0; i<s; ++i)
        if (ok(table.size(), x+1) && ok(table.size(), y+1+i))
            table[y+1+i][x+1] = '\\';
    if (ok(table.size(), x) && ok(table.size(), y+s+1))
        table[y+s+1][x] = '^';

}

int main()
{
    int m, n;
    while (cin>>m>>n)
    {
        vector<string> table(m, string(m, '.'));
        for (int i=0; i<n; ++i)
        {
            int s, x, y;
            cin>>s>>x>>y;

            if (s == 0)
                draw_stump(table, x, y);
            else
                draw_tree(table, x, y, s);
        }

        for (int i=0; i<m+2; ++i)
            cout<<"*";
        cout<<endl;

        for (int i=m-1; i>=0; --i)
            cout<<"*"<<table[i]<<"*"<<endl;

        for (int i=0; i<m+2; ++i)
            cout<<"*";
        cout<<endl;
        cout<<endl;
    }
    return 0;
}
